
'*******************
'                  '
' Uint64 utilities '
'                  ' 
'*******************

DECLARE CDECL _strtoui64Template(pointer nptr, pointer endptr, uint base), UINT64
DECLARE CDECL _ui64toa_sTemplate(UINT64 value, pointer buffer, INT sizeInCharacters, INT radix), INT

istring SMNumBlock[1024,5000]
Istring SMBlockIs[1024,5000]
istring SMMyTempBlock[1024,5000]
int SMCallFromGreater = 0

SUB HexToU64(string text),UINT64
   
	UINT64 value = 0
	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_strtoui64")
		
		IF proc THEN
			value = !<_strtoui64Template>proc(text, 0, 16)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN value
ENDSUB


SUB HEX$U64(UINT64 value),string
	string buffer = ""

	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_ui64toa_s")
		
		IF proc THEN
			value = !<_ui64toa_sTemplate>proc(value, buffer, 200, 16)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN buffer
ENDSUB

SUB ValU64(string text),UINT64
   
	UINT64 value = 0
	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_strtoui64")
		
		IF proc THEN
			value = !<_strtoui64Template>proc(text, 0, 10)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN value
ENDSUB

SUB STR$U64(UINT64 value),string
	string buffer = ""

	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_ui64toa_s")
		
		IF proc THEN
			value = !<_ui64toa_sTemplate>proc(value, buffer, 200, 10)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN UCASE$(buffer)
ENDSUB

SUB U64ToBase(UINT64 value,int Base),string
	string buffer = ""

	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_ui64toa_s")
		
		IF proc THEN
			value = !<_ui64toa_sTemplate>proc(value, buffer, 200, Base)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN UCASE$(buffer)
ENDSUB

SUB STR$64(INT64 value),string
	string buffer = ""

	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_i64toa_s")
		
		IF proc THEN
			value = !<_ui64toa_sTemplate>proc(value, buffer, 200, 10)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN UCASE$(buffer)
ENDSUB

SUB VAL64(string text),INT64
   
	INT64 value = 0
	UINT hInst=LoadLibrary("msvcrt.dll")
		
	IF hInst THEN
		UINT proc = GetProcAddress(hInst, "_strtoui64")
		
		IF proc THEN
			value = !<_strtoui64Template>proc(text, 0, 10)
		ENDIF
		
		FreeLibrary(hInst)
	ENDIF
	
	RETURN value
ENDSUB

sub MID$U64(uint64 valueu64,int pos,int lnth),string
    return mid$(STR$U64(valueu64),pos,lnth)
endsub

sub ADDU64(uint64 First64,uint64 Second64),uint64
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    return VALU64(ADDU64STR(First64$,Second64$))
endsub

sub ADDU64STR(string SMString1,string SMString2),string

    string SMString1In = SMString1
    string SMString2In = SMString2
    string SMWhl = ""
	 string SMWStringN = ""
	 string SMDV$  = ""
	 string SMDV2$ = ""
    string SMAU$ = "" 
    istring SMRT[5000] 
    int SMRTCount = 0
	 int SMDV = 0
	 int SMDV2 = 0
	 int CaryOne = 0
    int SMAU = 0
    int SMLoop = 0
    int ADDU64S1 = len(SMString1In)
    int ADDU64S2 = len(SMString2In)

    if ADDU64S1 < ADDU64S2 'Swap strings around.
       string SMString1InT = SMString1In
       string SMString2InT = SMString2In
       SMString1In = SMString2InT
       SMString2In = SMString1InT
    endif

    SMRTCount = 0

	 SMWStringN = space$(len(SMString1In)-len(SMString2In))
	 SMWStringN = SMWStringN + ltrim$(SMString2In)

	 for SMLoop = Len(SMString1In) to 1 Step -1

        SMRTCount ++

		  SMDV$ = mid$(SMString1In,SMLoop,1)
		  SMDV = val(SMDV$)

		  SMDV2$ = mid$(SMWStringN,SMLoop,1)
		  SMDV2 = val(SMDV2$)
 
        if CaryOne = 1
           CaryOne = 0
           SMDV = SMDV + val(mid$(SMAU$,1,1))
        endif 

        SMAU = 0
        SMAU = SMDV + SMDV2
        SMAU$ = ""
        SMAU$ = ltrim$(str$(SMAU))

        if len(SMAU$) = 2
           CaryOne = 1
           SMRT[SMRTCount] = mid$(SMAU$,2,1)
        else 
           SMRT[SMRTCount] = SMAU$
        endif

	 SMWhl = SMWhl + SMRT[SMRTCount]

	 next SMLoop

	 SMWhl = SMReverseString(SMWhl)

return SMWhl
endsub

sub SMReverseString(string SMAstringIn),string 

	 string SMReturnIstringY = ""
	 int SMLoop = 0
	 istring SMR[5000] = ""

	 for SMLoop = 1 to len(SMAstringIn)+1
	 	  SMR[SMLoop-1] = mid$(SMAstringIn,SMLoop,1)
	 next SMLoop

    for SMLoop = 1 to len(SMAstringIn)+1
        int ls = len(SMAstringIn)
        int rp = ls - SMLoop 
        SMReturnIstringY[SMLoop-1] = SMR[rp] + SMReturnIstringY
    next SMLoop

    SMReturnIstringY = mid$(SMReturnIstringY,1,len(SMAstringIn))

return SMReturnIstringY
endsub

sub SUBU64(uint64 First64,uint64 Second64),uint64
    string First64$  = STR$U64(First64)
    string Second64$ = STR$U64(Second64)
    return VALU64(SUBU64STR(First64$,Second64$))
endsub

sub SUBU64STR(string SMString1,string SMString2),string
    string SMString1In = SMString1
    string SMString2In = SMString2
	 istring SMWhl[5000] = ""
	 istring SMWStringN[5000] = ""
	 istring SMSwap1[1024] = ""
	 istring SMSwap2[1024] = ""
	 string SMDV$  = ""
	 string SMDV2$ = ""
    string SMAU$ = "" 
    istring SMRT[5000]
    int SMRTCount = 0
	 int SMDV = 0
	 int SMDV2 = 0
    int SMSame = 0
    int SMAU = 0
    int SMLoop = 0
    int SMNeg = 0
	 int SMCaryOne = 0

    int SUBU64S1 = len(SMString1In)
    int SUBU64S2 = len(SMString2In)

    if SUBU64S1 < SUBU64S2 'Swap strings around.
       string SMString1InT = SMString1In
       string SMString2InT = SMString2In
       SMString1In = SMString2InT
       SMString2In = SMString1InT
    endif

    SMRTCount = 0

    if len(SMString2In) < len(SMString1In) 
       goto Subtract
    endif

    if len(SMString2In) > len(SMString1In) 
       SMNeg = 1
    endif

    if len(SMString2In) = len(SMString1In)

    label SUBJumpRound
	 for SMLoop = 1 to Len(SMString1In)
        SMSame = 1
        SMRTCount ++

		  SMDV$ = mid$(SMString1In,SMLoop,1)
		  SMDV = val(SMDV$)

		  SMDV2$ = mid$(SMString2In,SMLoop,1)
		  SMDV2 = val(SMDV2$)

        if SMDV2 < SMDV 
           SMSame = 0
           breakfor
        endif

        if SMDV2 > SMDV
           SMSame = 0 
           SMNeg = 1
           SMSwap1 = SMString1In
           SMSwap2 = SMString2In
           SMString2In = SMSwap1
           SMString1In = SMSwap2
           breakfor
        endif

     next SMLoop
 
    endif

    label Subtract
    SMRTCount = 0

	 SMWStringN = ""

    for SMLoop = 1 to (len(SMString1In)-len(SMString2In))
	     SMWStringN = SMWStringN + "0"
    next SMLoop

	 SMWStringN = SMWStringN + ltrim$(SMString2In)

	 for SMLoop = Len(SMString1In) to 1 Step -1

        SMRTCount ++

		  SMDV$ = mid$(SMString1In,SMLoop,1)
		  SMDV  = val(SMDV$)

		  SMDV2$ = mid$(SMWStringN,SMLoop,1)
		  SMDV2  = val(SMDV2$)

        if SMCaryOne = 1
           if SMLoop = 0
              SMCaryOne = 1
           else
              SMCaryOne = 0
           endif
           SMDV2 = SMDV2 + 1
        endif 

		  if SMDV < SMDV2
			  int SMDVT = 10 + SMDV
			  SMDV2 = SMDVT - SMDV2
			  SMCaryOne = 1
           SMAU = 0
           SMAU = SMDV2
           goto skipminus
		  endif

        SMAU = 0
        SMAU = SMDV - SMDV2

        label skipminus
        SMAU$ = ""
        SMAU$ = ltrim$(str$(SMAU))

        if len(SMAU$) = 2
           SMCaryOne = 1
           SMRT[SMRTCount] = mid$(SMAU$,2,1)
        else 
           SMRT[SMRTCount] = SMAU$
        endif

	 SMWhl = SMWhl + SMRT[SMRTCount]

	 next SMLoop

	 SMWhl = SMReverseString(SMWhl)

return SMWhl
endsub

sub GreaterThanU64(uint64 First64,uint64 Second64),int
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    return GreaterThanU64STR(First64$,Second64$)
endsub

sub GreaterThanU64STR(string SMAstringIn,string SMAstringIn2),int
    string SMResturnIstringC = ""
	 int SMLoop = 0
    int op = 0
    int op2 = 0
    int SMDecFound = 0
    int SMThisDecL = 0
    int SMLongDecL = 0
    int SMThisintL = 0
    int SMLongintL = 0
    int SMMinus1Test = 0
    int SMMinus2Test = 0

    int DoAlpha = 0
    int DoNum = 0
    int DoStop = 0

    for op = 1 to 5000
        SMBlockIs[0,op] = ""
        SMNumBlock[0,op] = "" 
        SMMyTempBlock[0,op] = ""
    next op

    if instr(SMAstringIn,"-")
       SMMinus1Test = 1
    endif

    if instr(SMAstringIn2,"-")
       SMMinus2Test = 1
    endif

    if SMMinus1Test = 1 and SMMinus2Test = 0
       'return 0
    endif

    if SMMinus1Test = 0 and SMMinus2Test = 1
       'return 1
    endif

    SMBC = 2

    for op = 0 to SMBC 
        'print SMGetNumBlockX(SMAstringIn,op+1)

        if op = 0

           'if SMMinus1Test = 1
           '    SMMyTempBlock[0,op] = mid$(SMAStringIn,2,len(SMAStringIn))         
           'else  
              SMMyTempBlock[0,op] = SMAStringIn
           'endif

        else

           'if SMMinus2Test = 1
           '    SMMyTempBlock[0,op] = mid$(SMAStringIn2,2,len(SMAStringIn2))         
           'else  
              SMMyTempBlock[0,op] = SMAStringIn2
           'endif

        endif

        if instr(SMMyTempBlock[0,op],".")
           SMDecFound = 1
           SMThisDecL = len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

           if SMThisDecL > SMLongDecL
              SMLongDecL = SMThisDecL 
           endif

        endif

    next op

    if SMDecFound = 1

        for op = 0 to SMBC 

           SMThisintL = len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

           if SMThisintL > SMLongintL
              SMLongintL = SMThisintL 
              string SMLongest = ""
              SMLongest = SMMyTempBlock[0,op]
           endif

			   if instr(SMMyTempBlock[0,op],".")
               int SMMyintL = 0
               SMMyintL = SMLongDecL - len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

               if SMMyintL > 0
						for op2 = 1 to SMMyintL 
							 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
						next op2
               endif

            endif

			   if !instr(SMMyTempBlock[0,op],".")

               int SMLgFlag = 0

               if SMMyTempBlock[0,op] = SMLongest
                  SMLgFlag = 1
               endif

				   SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "."

				   for op2 = 1 to SMLongDecL 
						 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
				   next op2

               if SMLgFlag = 1
                  'SMLongest = SMMyTempBlock[0,op]
                  'print " longest is now ",SMLongest
	            endif

			   endif

        next op

    else

		  SMThisintL = len(mid$(SMMyTempBlock[0,op],1,len(SMMyTempBlock[0,op])))

		  if SMThisintL > SMLongintL
			  SMLongintL = SMThisintL 
		  endif

    endif

    for op = 0 to SMBC 
         if SMMyTempBlock[0,op] <> SMLongest 
            int SMMyAdj = 0
            SMMyAdj = SMLongintL - len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

				for op2 = 1 to SMMyAdj
					 SMMyTempBlock[0,op] = "0" + SMMyTempBlock[0,op]
				next op2
         endif
    next op

    for op = 0 to SMBC 
        SMNumBlock[0,op] = SMMyTempBlock[0,op]
    next op

	 return SMDummySortBlocks(2) 'Sort

return 0 
endsub

sub SMDummySortBlocks(int SMNumc),INT 
    string SMSwap1B = ""
    string SMSwap2B = ""
    int SMLC = 0

do

   SMLC ++

	for SMLoop = 0 to SMNumc -2
       if SMGreaterThanTest(SMNumBlock[0,SMLoop],SMNumBlock[0,SMLoop+1])
          return 1
       else
          return 0
		 endif

	next SMLoop

until SMLC = SMNumc

return 0
endsub

sub SMGreaterThanTest(string SMAStringIn,STRIng SMAStringIn2),int 
    int SMLessThanRet = 0
    int SMCallFromGreater = 0

    if instr(SMAStringIn,"-") 
       if mid$(SMAStringIn2,1,1) <> "-"
          return 0 
       endif
    endif

    if instr(SMAStringIn2,"-") 
       if mid$(SMAStringIn,1,1) <> "-"
          return 1 
       endif
    endif

    if instr(SMAStringIn,"-") and instr(SMAStringIn2,"-")
       SMCallFromGreater = 1
       return SMLessThanTest(SMAStringIn,SMAStringIn2)
    endif

    if len(SMAStringIn) > len(SMAStringIn2)
       return 1
    endif

    if len(SMAStringIn) < len(SMAStringIn2)
       return 0
    endif

    if len(SMAStringIn) = len(SMAStringIn2)

       'if mid$(SMAStringIn2,1,1) = "0"
       '   SMAStringIn2 = mid$(SMAStringIn2,2,len(SMAStringIn2))
       '   SMAStringIn2 = SMAStringIn2 + "0" 
          'return 0 
       'endif 

		 for SMLoop = 1 to len(SMAStringIn)
			  int SMLTV1 = 0
			  int SMLTV2 = 0

			  SMLTV1 = val(mid$(SMAStringIn,SMLoop,1))
			  SMLTV2 = val(mid$(SMAStringIn2,SMLoop,1))

			  if SMLTV1 < SMLTV2
				  SMLessThanRet = 0
				  breakfor
			  endif

			  if SMLTV1 > SMLTV2
				  SMLessThanRet = 1
				  breakfor
			  endif

		 next SMLoop
    endif 
 
return SMLessThanRet
endsub

sub SMLessThanTest(string SMAStringIn,STRIng SMAStringIn2),int 
    int SMLessThanRet = 0

    if instr(SMAStringIn,"-") 
       if mid$(SMAStringIn2,1,1) <> "-"
          return 1 
       endif
    endif

    if instr(SMAStringIn2,"-") 
       if mid$(SMAStringIn,1,1) <> "-"
          return 0 
       endif
    endif

    if instr(SMAStringIn,"-") and instr(SMAStringIn2,"-") and SMCallFromGreater <> 1
       return SMGreaterThanTest(SMAStringIn,SMAStringIn2)
    endif

    if len(SMAStringIn) < len(SMAStringIn2)
       return 1
    endif

    if len(SMAStringIn) > len(SMAStringIn2)
       return 0
    endif

    if len(SMAStringIn) = len(SMAStringIn2)

       if mid$(SMAStringIn2,1,1) = "0"
          SMAStringIn2 = mid$(SMAStringIn2,2,len(SMAStringIn2))
          SMAStringIn2 = SMAStringIn2 + "0" 
          'return 0 
       endif 

		 for SMLoop = 1 to len(SMAStringIn)
			  int SMLTV1 = 0
			  int SMLTV2 = 0

			  SMLTV1 = val(mid$(SMAStringIn,SMLoop,1))
			  SMLTV2 = val(mid$(SMAStringIn2,SMLoop,1))

			  if SMLTV1 > SMLTV2
				  SMLessThanRet = 0
				  breakfor
			  endif

			  if SMLTV1 < SMLTV2
				  SMLessThanRet = 1
				  breakfor
			  endif

		 next SMLoop
    endif 
 
return SMLessThanRet
endsub

sub LessThanU64(uint64 First64,uint64 Second64),int
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    return LessThanU64STR(First64$,Second64$)
endsub

sub LessThanU64STR(string SMAstringIn,string SMAstringIn2),int
    SMResturnIstringC = ""
	 int SMLoop = 0
    int op = 0
    int op2 = 0
    int SMDecFound = 0
    int SMThisDecL = 0
    int SMLongDecL = 0
    int SMThisintL = 0
    int SMLongintL = 0
    int SMMinus1Test = 0
    int SMMinus2Test = 0
    int SMLessResult = 0

    int DoAlpha = 0
    int DoNum = 0
    int DoStop = 0

    for op = 1 to 5000
        SMBlockIs[0,op] = ""
        SMNumBlock[0,op] = "" 
        SMMyTempBlock[0,op] = ""
    next op

    if instr(SMAstringIn,"-")
       SMMinus1Test = 1
    endif

    if instr(SMAstringIn2,"-")
       SMMinus2Test = 1
    endif

    if SMMinus1Test = 1 and SMMinus2Test = 0
       return 1
    endif

    if SMMinus1Test = 0 and SMMinus2Test = 1
       return 0
    endif

    'print " blocks ",SMCountNumBlocks(SMAstringIn)

    SMBC = 2

    for op = 0 to SMBC 
        'print SMGetNumBlockX(SMAstringIn,op+1)

        if op = 0
           SMMyTempBlock[0,op] = SMAStringIn
        else
           SMMyTempBlock[0,op] = SMAStringIn2
        endif

        if instr(SMMyTempBlock[0,op],".")
           SMDecFound = 1
           SMThisDecL = len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

           if SMThisDecL > SMLongDecL
              SMLongDecL = SMThisDecL 
           endif

        endif

    next op

    if SMDecFound = 1

        for op = 0 to SMBC 

           SMThisintL = len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

           if SMThisintL > SMLongintL
              SMLongintL = SMThisintL 
              string SMLongest = ""
              SMLongest = SMMyTempBlock[0,op]
           endif

			   if instr(SMMyTempBlock[0,op],".")
               int SMMyintL = 0
               SMMyintL = SMLongDecL - len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

               if SMMyintL > 0
						for op2 = 1 to SMMyintL 
							 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
						next op2
               endif

            endif

			   if !instr(SMMyTempBlock[0,op],".")

               int SMLgFlag = 0

               if SMMyTempBlock[0,op] = SMLongest
                  SMLgFlag = 1
               endif

				   SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "."

				   for op2 = 1 to SMLongDecL 
						 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
				   next op2

               if SMLgFlag = 1
                  'SMLongest = SMMyTempBlock[0,op]
                  'print " longest is now ",SMLongest
	            endif

			   endif

        next op

    else

		  SMThisintL = len(mid$(SMMyTempBlock[0,op],1,len(SMMyTempBlock[0,op])))

		  if SMThisintL > SMLongintL
			  SMLongintL = SMThisintL 
		  endif

    endif

    for op = 0 to SMBC 
         if SMMyTempBlock[0,op] <> SMLongest 
            int SMMyAdj = 0
            SMMyAdj = SMLongintL - len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

				for op2 = 1 to SMMyAdj
					 SMMyTempBlock[0,op] = "0" + SMMyTempBlock[0,op]
				next op2
         endif
    next op

    for op = 0 to SMBC 
        SMNumBlock[0,op] = SMMyTempBlock[0,op]
    next op

	 SMLessresult = SMDummySortBlocks2(2) 'Sort

    if SMMinus1Test = 1 and SMMinus2Test = 1

       if SMAstringIn = SMAstringIn2
          return 0
       endif

       if SMLessResult = 1 
          SMLessResult = 0
          return SMLessResult
       endif

       if SMLessResult = 0 
          SMLessResult = 1
          return SMLessResult
       endif

    endif

    return SMLessResult

endsub

sub SMDummySortBlocks2(int SMNumc),INT 
    string SMSwap1B = ""
    string SMSwap2B = ""
    int SMLC = 0

do

   SMLC ++

	for SMLoop = 0 to SMNumc -2
       if SMLessThanTest(SMNumBlock[0,SMLoop],SMNumBlock[0,SMLoop+1])
          return 1
       else
          return 0
		 endif

	next SMLoop

until SMLC = SMNumc

return 0
endsub

sub GreaterThanEqualsU64(uint64 First64,uint64 Second64),int
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    return GreaterThanEqualsU64STR(First64$,Second64$)
endsub

sub LessThanEqualsU64(uint64 First64,uint64 Second64),int
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    return LessThanEqualsU64STR(First64$,Second64$)
endsub

sub GreaterThanEqualsU64STR(string SMAstringIn,string SMAstringIn2),int
    string SMResturnIstringC = ""
	 int SMLoop = 0
    int op = 0
    int op2 = 0
    int SMDecFound = 0
    int SMThisDecL = 0
    int SMLongDecL = 0
    int SMThisintL = 0
    int SMLongintL = 0
    int SMMinus1Test = 0
    int SMMinus2Test = 0

    int DoAlpha = 0
    int DoNum = 0
    int DoStop = 0

    for op = 1 to 5000
        SMBlockIs[0,op] = ""
        SMNumBlock[0,op] = "" 
        SMMyTempBlock[0,op] = ""
    next op

    if instr(SMAstringIn,"-")
       SMMinus1Test = 1
    endif

    if instr(SMAstringIn2,"-")
       SMMinus2Test = 1
    endif

    if SMMinus1Test = 1 and SMMinus2Test = 0
       'return 0
    endif

    if SMMinus1Test = 0 and SMMinus2Test = 1
       'return 1
    endif

    SMBC = 2

    for op = 0 to SMBC 
        'print SMGetNumBlockX(SMAstringIn,op+1)

        if op = 0

           'if SMMinus1Test = 1
           '    SMMyTempBlock[0,op] = mid$(SMAStringIn,2,len(SMAStringIn))         
           'else  
              SMMyTempBlock[0,op] = SMAStringIn
           'endif

        else

           'if SMMinus2Test = 1
           '    SMMyTempBlock[0,op] = mid$(SMAStringIn2,2,len(SMAStringIn2))         
           'else  
              SMMyTempBlock[0,op] = SMAStringIn2
           'endif

        endif

        if instr(SMMyTempBlock[0,op],".")
           SMDecFound = 1
           SMThisDecL = len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

           if SMThisDecL > SMLongDecL
              SMLongDecL = SMThisDecL 
           endif

        endif

    next op

    if SMDecFound = 1

        for op = 0 to SMBC 

           SMThisintL = len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

           if SMThisintL > SMLongintL
              SMLongintL = SMThisintL 
              string SMLongest = ""
              SMLongest = SMMyTempBlock[0,op]
           endif

			   if instr(SMMyTempBlock[0,op],".")
               int SMMyintL = 0
               SMMyintL = SMLongDecL - len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

               if SMMyintL > 0
						for op2 = 1 to SMMyintL 
							 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
						next op2
               endif

            endif

			   if !instr(SMMyTempBlock[0,op],".")

               int SMLgFlag = 0

               if SMMyTempBlock[0,op] = SMLongest
                  SMLgFlag = 1
               endif

				   SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "."

				   for op2 = 1 to SMLongDecL 
						 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
				   next op2

               if SMLgFlag = 1
                  'SMLongest = SMMyTempBlock[0,op]
                  'print " longest is now ",SMLongest
	            endif

			   endif

        next op

    else

		  SMThisintL = len(mid$(SMMyTempBlock[0,op],1,len(SMMyTempBlock[0,op])))

		  if SMThisintL > SMLongintL
			  SMLongintL = SMThisintL 
		  endif

    endif

    for op = 0 to SMBC 
         if SMMyTempBlock[0,op] <> SMLongest 
            int SMMyAdj = 0
            SMMyAdj = SMLongintL - len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

				for op2 = 1 to SMMyAdj
					 SMMyTempBlock[0,op] = "0" + SMMyTempBlock[0,op]
				next op2
         endif
    next op

    for op = 0 to SMBC 
        SMNumBlock[0,op] = SMMyTempBlock[0,op]
    next op

	 return SMDummySortBlocks3(2) 'Sort

return 0 
endsub

sub SMDummySortBlocks3(int SMNumc),INT 
    string SMSwap1B = ""
    string SMSwap2B = ""
    int SMLC = 0

do

   SMLC ++

	for SMLoop = 0 to SMNumc -2
       if SMNumBlock[0,SMLoop] = SMNumBlock[0,SMLoop+1]
          return 1
       endif

       if SMGreaterThanTest(SMNumBlock[0,SMLoop],SMNumBlock[0,SMLoop+1])
          return 1
       else
          return 0
		 endif

	next SMLoop

until SMLC = SMNumc

return 0
endsub

sub LessThanEqualsU64STR(string SMAstringIn,string SMAstringIn2),int
    string SMResturnIstringC = ""
	 int SMLoop = 0
    int op = 0
    int op2 = 0
    int SMDecFound = 0
    int SMThisDecL = 0
    int SMLongDecL = 0
    int SMThisintL = 0
    int SMLongintL = 0
    int SMMinus1Test = 0
    int SMMinus2Test = 0
    int SMLessResult = 0

    int DoAlpha = 0
    int DoNum = 0
    int DoStop = 0

    for op = 1 to 5000
        SMBlockIs[0,op] = ""
        SMNumBlock[0,op] = "" 
        SMMyTempBlock[0,op] = ""
    next op

    if instr(SMAstringIn,"-")
       SMMinus1Test = 1
    endif

    if instr(SMAstringIn2,"-")
       SMMinus2Test = 1
    endif

    if SMMinus1Test = 1 and SMMinus2Test = 0
       return 1
    endif

    if SMMinus1Test = 0 and SMMinus2Test = 1
       return 0
    endif

    'print " blocks ",SMCountNumBlocks(SMAstringIn)

    SMBC = 2

    for op = 0 to SMBC 
        'print SMGetNumBlockX(SMAstringIn,op+1)

        if op = 0
           SMMyTempBlock[0,op] = SMAStringIn
        else
           SMMyTempBlock[0,op] = SMAStringIn2
        endif

        if instr(SMMyTempBlock[0,op],".")
           SMDecFound = 1
           SMThisDecL = len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

           if SMThisDecL > SMLongDecL
              SMLongDecL = SMThisDecL 
           endif

        endif

    next op

    if SMDecFound = 1

        for op = 0 to SMBC 

           SMThisintL = len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

           if SMThisintL > SMLongintL
              SMLongintL = SMThisintL 
              string SMLongest = ""
              SMLongest = SMMyTempBlock[0,op]
           endif

			   if instr(SMMyTempBlock[0,op],".")
               int SMMyintL = 0
               SMMyintL = SMLongDecL - len(mid$(SMMyTempBlock[0,op],instr(SMMyTempBlock[0,op],".")+1,len(SMMyTempBlock[0,op])))

               if SMMyintL > 0
						for op2 = 1 to SMMyintL 
							 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
						next op2
               endif

            endif

			   if !instr(SMMyTempBlock[0,op],".")

               int SMLgFlag = 0

               if SMMyTempBlock[0,op] = SMLongest
                  SMLgFlag = 1
               endif

				   SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "."

				   for op2 = 1 to SMLongDecL 
						 SMMyTempBlock[0,op] = SMMyTempBlock[0,op] + "0"
				   next op2

               if SMLgFlag = 1
                  'SMLongest = SMMyTempBlock[0,op]
                  'print " longest is now ",SMLongest
	            endif

			   endif

        next op

    else

		  SMThisintL = len(mid$(SMMyTempBlock[0,op],1,len(SMMyTempBlock[0,op])))

		  if SMThisintL > SMLongintL
			  SMLongintL = SMThisintL 
		  endif

    endif

    for op = 0 to SMBC 
         if SMMyTempBlock[0,op] <> SMLongest 
            int SMMyAdj = 0
            SMMyAdj = SMLongintL - len(mid$(SMMyTempBlock[0,op],1,instr(SMMyTempBlock[0,op],".")-1))

				for op2 = 1 to SMMyAdj
					 SMMyTempBlock[0,op] = "0" + SMMyTempBlock[0,op]
				next op2
         endif
    next op

    for op = 0 to SMBC 
        SMNumBlock[0,op] = SMMyTempBlock[0,op]
    next op

	 SMLessresult = SMDummySortBlocks4(2) 'Sort

    if SMMinus1Test = 1 and SMMinus2Test = 1

       if SMAstringIn = SMAstringIn2
          return 0
       endif

       if SMLessResult = 1 
          SMLessResult = 0
          return SMLessResult
       endif

       if SMLessResult = 0 
          SMLessResult = 1
          return SMLessResult
       endif

    endif

    return SMLessResult

return 0 
endsub

sub SMDummySortBlocks4(int SMNumc),INT 
    string SMSwap1B = ""
    string SMSwap2B = ""
    int SMLC = 0

	 do
		SMLC ++
		for SMLoop = 0 to SMNumc -2
			 if SMNumBlock[0,SMLoop] = SMNumBlock[0,SMLoop+1] 
				 return 1
			 endif

			 if SMLessThanTest(SMNumBlock[0,SMLoop],SMNumBlock[0,SMLoop+1])
				 return 1
			 else
				 return 0
			 endif

		next SMLoop
	 until SMLC = SMNumc

return 0
endsub

sub NotEqualU64(uint64 First64,uint64 Second64),int
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    if GreaterThanU64STR(First64$,Second64$) = 1
       return 1
    endif

    if LessThanU64STR(First64$,Second64$) = 1
       return 1
    endif

    return 0
endsub

sub NotEqualU64STR(string First64,string Second64),int
    string First64$  = ltrim$(First64)
    string Second64$ = ltrim$(Second64)
    if GreaterThanU64STR(First64$,Second64$) = 1
       if LessThanU64STR(First64$,Second64$) = 1
          return 1
       endif
    endif
    return 0
endsub

sub EqualsU64(uint64 First64,uint64 Second64),int
    string First64$  = ltrim$(STR$U64(First64))
    string Second64$ = ltrim$(STR$U64(Second64))
    if GreaterThanU64STR(First64$,Second64$) = 0
       if LessThanU64STR(First64$,Second64$) = 0
          return 1
       endif
    endif
    return 0
endsub

sub EqualsU64STR(string First64,string Second64),int
    string First64$  = ltrim$(First64)
    string Second64$ = ltrim$(Second64)
    if GreaterThanU64STR(First64$,Second64$) = 0
       if LessThanU64STR(First64$,Second64$) = 0
          return 1
       endif
    endif
    return 0
endsub
